<?php
/**
 * Basic Code Examples in PHP
 * Lecture 16: 11.02.18
 * ---------------------------
 * - Comments
 * - Arithmetic
 * - Variables
 * - Strings
 * - Booleans
 * - Loops
 * - Arrays
 * - Functions
 */

# By default, a .php file outputs text as HTML (in the body) in the browser.
# We don't use PHP to write HTML pages in this course, so we want to focus
# on outputting text or JSON in our PHP services. For now, set header
# to plain text in order to see \n characters in your output! We'll learn about
# JSON output next week.
header("Content-type: text/plain");

# -----------------------------------------------------
# Variables in PHP
# -----------------------------------------------------
# - always start with $ (both when defining and using!)
# let name = "Mowgli Hovik"; (JS example)
# String name = "Mowgli Hovik"; (Java example)
$name = "Mowgli Hovik"; # PHP example

# -----------------------------------------------------
# Strings 
# -----------------------------------------------------
# -----------------------------------------------------
# Common String Functions
# -----------------------------------------------------
# strlen, strpos, substr, strtolower, strtoupper, trim
# explode, implode
echo "Melissa " . "Hovik";

# -----------------------------------------------------
# Interpreted Strings
# -----------------------------------------------------
# Strings inside " " are interpreted (variables will have
# their values inserted into the string)
$age = 16;
echo "You are $age years old.\n";

# Strings inside ' ' are NOT!
# It's best to avoid ambiguity by enclosing variables in { }
echo "Today is your $ageth birthday.\n";
echo "Today is your {$age}th birthday.\n";

# -----------------------------------------------------
# Booleans
# -----------------------------------------------------
# Similar "truthy/falsey" properties as JS
# FALSE: 0, 0.0, "", "0", NULL, empty arrays
/*
$feels_like_summer = FALSE;
$php_is_rad = TRUE;
$coffee_drinks = 12;
$nonzero = (bool) $coffee_drinks;
*/

# A nuance (what does it print out when you uncomment?):
// echo FALSE;
// echo TRUE;

# -----------------------------------------------------
# NOTE: This is where we stopped in lecture - we'll review
# loop/conditional/arrays/functions on Monday, but include
# them here to practice on your own if you'd like.
# -----------------------------------------------------

# -----------------------------------------------------
# For Loops
# -----------------------------------------------------
/*
// JavaScript:
for (let i = 0; i < 10; i++) {
  console.log(i + " squared is " + i * i);
}
// PHP:
// TODO
*/

# -----------------------------------------------------
# If/Else
# -----------------------------------------------------
/*
// JavaScript
let a = 1;
let b = 2;
if (a < b) {
  console.log("a is less than b!");
} else if (b < a)
  console.log("b is less than a!");
} else {
  console.log("b equals a!");
}
*/
/*
// PHP
// TODO
*/

# -----------------------------------------------------
# Arrays
# -----------------------------------------------------
/*
 - array() # create empty
 - array(val0, val1, val2, ...) # create filled
 - $arr[0]; # get element value at index 0
 - $arr[0] = "foo"; # set element value to "foo" at index 0
 - $arr[] = "bar"; # append "bar" to end of array
 - print array using print_r($arr);
*/
/*
Example:
$pups = array("Mowgli", "Abby", "Archie", "Bailey");
*/

# -----------------------------------------------------
# Common Array Functions
# -----------------------------------------------------
# count($arr) - returns size of $arr
# print_r($arr) - prints (not so great) array representation
# array_pop($arr) - remove/return element at end of $arr
# array_push($arr, $val) - add $val at end of $arr
# array_shift($arr) - remove/return element at start of $arr
# array_unshift($arr, $val) - add $val at start of $arr
# sort($arr) - sort $arr on natural ordering
# array_reverse($arr) - reverse $arr
# $arr2 = array_slice($arr, $start, $end) - return array between $start/$end indices

# -----------------------------------------------------
# Associative Arrays
# -----------------------------------------------------
/*
- We will use these to build JSON output for our PHP web services!
- Analogous to Maps in Java, dictionaries in Python
- array(key0 => val0, key1 => val1, ...) # create
- $arr[$keyname] = $val; # sets key to be value (may overwrite)
*/
/*
$petages = array();
$pets["Spot"] = 16;
$pets["Mowgli"] = 1;

$costs = array("coffee" => 1.25, "espresso" => 2.15);
$costs["tea"] = 1.50;
$costs["espresso"] = 1.75; # sale!
*/

# -----------------------------------------------------
# foreach loops
# -----------------------------------------------------
/*
 * Convenient ways to loop over each elements with indices
 * Syntax:
 * foreach ($arr as $variablename) {
 *
 * }
 */
 // Example
 /*
foreach ($pups as $pup) {
  echo "Mowgli boops {$pup}\n"; # even himself
}
 */

# -----------------------------------------------------
# Functions
# -----------------------------------------------------
/*
 * Syntax:
 *
 function fun_name(param_name0, ..., param_name1) {
   statements;
 }
 */
// Exercise: Write a function arr_to_string to replace print_r for arrays!
// We want:
// arr_to_string($pups) to return:
//   "[Mowgli, Abby, Archie, Bailey]")
?>
